/***********************************************************************
                       Example to interface the
                  PKWARE Data Compression Library (TM)
                                 with
                  Microsoft Optimizing C Compiler (R)
         Copyright 1990-91, By PKWARE Inc.  All Rights Reserved.
***********************************************************************/

#include <stdio.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include <malloc.h>
#include <memory.h>

#include "implode.h"

int InFile, OutFile;

/*
   Routine to supply data to the implode() or explode() routines.
   When this routine returns 0 bytes read, the implode() or explode()
   routines will terminate.
*/

unsigned far pascal ReadBuff(char far *buff, unsigned short int far *size)
{
   unsigned read = 0;

   _dos_read(InFile,buff,*size,&read);
   return(read);
}

/*
   Routine to write compressed data output from implode() or
   uncompressed data from explode()
*/

unsigned far pascal WriteBuff(char far *buff, unsigned short int far *size)
{
   unsigned wrote = 0;

   _dos_write(OutFile,buff,*size,&wrote);
   return(wrote);
}

void main(int a ,char *b[])
{
   char far *WorkBuff;                  /* Buffer for compression tables */
   unsigned error;
   unsigned type;
   unsigned dsize;

   strlwr(b[1]);
   
   if(a<3 || b[1][0]!='-' || (b[1][1]!='a' && b[1][1]!='x'))
      { puts("Use: EAzip {-a -x} InFile OutFile"); return; }

   if(b[1][1]!='a') goto EXP;


   if(_dos_creatnew(b[3],0,&OutFile))   /* File to hold compressed data */
   {
      if(_dos_creat(b[3],0,&OutFile))   /* File to hold compressed data */
      {
	 printf("Unable to open %s.",b[3]);
	 return;
      }
      else MakeHeader();
   }

   lseek(OutFile,0L,SEEK_END);

   WorkBuff=(char far *)_fmalloc(35256U);

   if (WorkBuff == NULL)
   {
      puts("Unable to allocate work buffer");
      return;
   }

   _splitpath(b[2],dr,dir,fn,ext);
   chdir(dir);

   if (_dos_open(b[2],O_RDONLY,&InFile) != 0)
   {
      puts("Unable to open input file");
      return;
   }

   puts("Calling Implode");

   type=CMP_BINARY;
   dsize=4096;
   implode(ReadBuff,WriteBuff,WorkBuff,&type,&dsize);

   _ffree(WorkBuff);

   _dos_close(InFile);
   _dos_close(OutFile);

   return;

   /* compression done, now try extracting the compressed file */

   EXP:

   WorkBuff=(char far *)_fmalloc(12574);

   if (WorkBuff == NULL)
   {
      puts("Unable to allocate work buffer");
      return;
   }

   if(_dos_open(b[2],O_RDONLY,&InFile))      /* Compressed file    */
   {
      puts("Unable to open input file");
      return;
   }
   if(_dos_creat(b[3],0,&OutFile))           /* File to extract to */
   {
      puts("Unable to open output file");
      return;
   }

   puts("Calling Explode");
   error=explode(ReadBuff,WriteBuff,WorkBuff);  /* Extract the file   */

   if (error)
      puts("Error in compressed file!");

   _ffree(WorkBuff);

   _dos_close(InFile);
   _dos_close(OutFile);
}

MakeHeader()
{
 int i;
   if(_dos_write(OutFile,"EAZIP",100,&i))
     { puts("Cannot write to open file."); return -1; }
}

