/***********************************************************************
		       Example to interface the
		  PKWARE Data Compression Library (TM)
				 with
		  Microsoft Optimizing C Compiler (R)
	 Copyright 1990-91, By PKWARE Inc.  All Rights Reserved.

	 BC++, ।  !!!
***********************************************************************/

#include <stdio.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include <alloc.h>
#include <mem.h>
#include <dir.h>
#include <sys\stat.h>

#include "implode.h"

 int InFile, OutFile;

/*
   Routine to supply data to the implode() or explode() routines.
   When this routine returns 0 bytes read, the implode() or explode()
   routines will terminate.
*/

unsigned far pascal ReadBuff(char far *buff, unsigned short int far *size)
{
 return _read(InFile,buff,*size);
}

/*
   Routine to write compressed data output from implode() or
   uncompressed data from explode()
*/

unsigned far pascal WriteBuff(char far *buff, unsigned short int far *size)
{
 return _write(OutFile,buff,*size);
}

void main(int a ,char *b[])
{
   char far *WorkBuff;                  /* Buffer for compression tables */
   unsigned error;
   unsigned type;
   unsigned dsize;

   strlwr(b[1]);

   if(a<3 || b[1][0]!='-' || (b[1][1]!='a' && b[1][1]!='x'))
      { puts("Use: EAzip {-a -x} InFile OutFile"); return; }

   if(b[1][1]!='a') goto EXP;


      if((OutFile = open(b[3],O_WRONLY|O_BINARY|O_CREAT|O_TRUNC,S_IREAD|S_IWRITE)) == -1)   /* File to hold compressed data */
      {
	 printf("IMPLODE: Unable to open %s.",b[3]);
	 return;
      }
      //else MakeHeader();

   lseek(OutFile,0L,SEEK_END);

   WorkBuff=(char far *)farmalloc(35256U);

   if (WorkBuff == NULL)
   {
      puts("Unable to allocate work buffer");
      return;
   }
/*
   fnsplit(b[2],dr,dir,fn,ext);
   chdir(dir);
*/
   if ((InFile = _open(b[2],O_RDONLY | O_BINARY)) == -1)
   {
      puts("Unable to open input file");
      return;
   }

   puts("Calling Implode");

   type=CMP_ASCII; //BINARY;
   dsize=4096;
   implode(ReadBuff,WriteBuff,WorkBuff,&type,&dsize);

   farfree(WorkBuff);

   _close(InFile);
   _close(OutFile);

   return;

   /* compression done, now try extracting the compressed file */

   EXP:

   WorkBuff=(char far *)farmalloc(12574);

   if (WorkBuff == NULL)
   {
      puts("Unable to allocate work buffer");
      return;
   }

   if ((InFile = _open(b[2],O_RDONLY | O_BINARY)) == -1)  /* Compressed file    */
   {
      puts("Unable to open input file");
      return;
   }
   if ((OutFile = open(b[3],O_WRONLY|O_BINARY|O_CREAT|O_TRUNC,S_IREAD|S_IWRITE)) == -1)   /* File to extract to */
   {
      puts("Unable to open output file");
      return;
   }

   puts("Calling Explode");
   error=explode(ReadBuff,WriteBuff,WorkBuff);  /* Extract the file   */

   if (error)
      printf("Error in compressed file! %d\n",error);

   farfree(WorkBuff);

   _close(InFile);
   _close(OutFile);
}

int MakeHeader()
{
 if (_write(OutFile,"EAZIP",100) == -1) {
    puts("Cannot write to open file.");
    return -1;
 }
}

