{***********************************************************************
                        Example to interface the
                   PKWARE Data Compression Library (TM)
                                  with
                              Turbo Pascal
           Copyright 1990-91, By PKWARE Inc.  All Rights Reserved.
 ***********************************************************************
}


program Compress;
{
   Demonstration program that shows how to use the
   PKWARE Data Compression Library

   This program takes a file called TEST.IN and compresses the file to
   a new file called TEST.CMP.  It then takes the TEST.CMP file and expands
   it back to it's original size, but to a file called TEST.EXT.

   Please Note: Very little error checking is done.
}

{$I-,S+,F+}
{$M 8192,0,655360}
{$L IMPLODE.OBJ}

uses dos;

const
  CMP_BINARY = 0;
  CMP_ASCII  = 1;

type
  BuffType = packed array [1..35256] of char;
  IntFunc = function(var Buff:BuffType; var bSize:Word): Word;

var
  DictionarySize:  Word;
  CompressionType: Word;
  FromFile:        File;
  ToFile:          File;
  Buffer:          Bufftype;
  Result:          Integer;
  Exploding:       Integer;
  OrigFile:        SearchRec;
  st,sk:           String;
  cb:              Byte;

function Implode(Read:IntFunc;
                 Write:IntFunc;
                 var Buf:BuffType;
                 var Ctype:Word;
                 var bSize:Word): Integer; far; external;

function Explode(Read:IntFunc;
                 Write:IntFunc;
                 var Buf:BuffType): Integer; far; external;


function ReadData(var Buffer : BuffType; var BufferSize : Word): Word; {far;}
var BytesRead:Word;
begin
   BlockRead(FromFile, Buffer, BufferSize, BytesRead);
   ReadData := BytesRead;
   if BytesRead>0 then write('r') else write(';');
end;


function WriteData(var Buffer : BuffType; var BytesRead : Word): Word; {far;}
var byteswritten:Word;
begin
  BlockWrite(ToFile, Buffer, BytesRead, BytesWritten);
  WriteData := BytesWritten;
  if BytesWritten>0 then write('W') else write('.');
end;


begin
  writeln;
  writeln('PKWARE Data Compression Libraries Example');
  writeln;

  sk:=paramstr(1);
  if not (sk[1] in ['D','E','d','e']) then halt;

  sk[1]:=upcase(sk[1]);
  st:=paramstr(2);
  Assign(FromFile,st);            { Open input file        }
  Reset(FromFile,1);
  cb:=pos('.',st);
  if cb<>0 then delete(st,cb,length(st)-cb+1);

 if sk[1]='E' then begin
    Assign(ToFile,st+'.E');       { Create output file     }
    Rewrite(ToFile,1);

    writeln('Imploding file   ',sk,' => ',st+'.E');

    DictionarySize  := 4096;
    CompressionType := CMP_BINARY;

    result:=implode(ReadData, WriteData, Buffer,CompressionType,DictionarySize);
                   end
              else begin
    Assign(ToFile,st+'.D');      { Create output file     }
    Rewrite(ToFile,1);

    writeln('Exploding file   ',sk,' => ',st+'.D');
    result := explode(ReadData, WriteData, Buffer);
                   end;
  writeln;

  Close(FromFile);
  Close(ToFile);

  writeln('Done!');

  if (result <> 0) then
    writeln('Error in compressed data!');
end.
